Index: /XIOS/dev/dev_olga/bld.cfg
===================================================================
--- /XIOS/dev/dev_olga/bld.cfg	(revision 1128)
+++ /XIOS/dev/dev_olga/bld.cfg	(revision 1129)
@@ -36,5 +36,6 @@
 #bld::target test_regular.exe
 #bld::target test_new_features.exe test_unstruct_complete.exe 
-#bld::target test_client.exe test_complete.exe
+#bld::target test_client.exe 
+bld::target test_complete.exe
 bld::target test_client.exe
 bld::exe_dep
Index: /XIOS/dev/dev_olga/src/distribution.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution.cpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/distribution.cpp	(revision 1129)
@@ -18,4 +18,9 @@
 }
 
+const CArray<size_t,1>& CDistribution:: getGlobalIndex() const 
+{ 
+  return globalIndex_; 
+}
+
 CDistribution::~CDistribution()
 { /* Nothing to do */ }
Index: /XIOS/dev/dev_olga/src/distribution.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution.hpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/distribution.hpp	(revision 1129)
@@ -35,5 +35,6 @@
     int getDims() const; //! Get dimension size
     int getRank() const; //! Get rank of current process
-
+    const CArray<size_t,1>& getGlobalIndex() const;
+    
   protected:
     virtual void createGlobalIndex() {};
Index: /XIOS/dev/dev_olga/src/distribution_client.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution_client.cpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/distribution_client.cpp	(revision 1129)
@@ -291,6 +291,6 @@
       nBeginLocal_.at(indexMap_[idx]+1) = 0;
       nBeginGlobal_.at(indexMap_[idx]+1) = domList[domIndex]->jbegin;
-      nZoomBegin_.at((indexMap_[idx]+1)) = domList[domIndex]->global_zoom_jbegin;
-      nZoomEnd_.at((indexMap_[idx]+1))   = domList[domIndex]->global_zoom_jbegin + domList[domIndex]->global_zoom_nj-1;
+      nZoomBegin_.at((indexMap_[idx]+1)) = 0; //domList[domIndex]->global_zoom_jbegin;
+      nZoomEnd_.at((indexMap_[idx]+1))   = domList[domIndex]->nj_glo.getValue()- 1; //domList[domIndex]->global_zoom_jbegin + domList[domIndex]->global_zoom_nj-1;
 
       dataBegin_.at(indexMap_[idx]+1) = domList[domIndex]->data_jbegin.getValue();
@@ -303,6 +303,6 @@
       nBeginLocal_.at(indexMap_[idx]) = 0;
       nBeginGlobal_.at(indexMap_[idx]) = domList[domIndex]->ibegin;
-      nZoomBegin_.at((indexMap_[idx])) = domList[domIndex]->global_zoom_ibegin;
-      nZoomEnd_.at((indexMap_[idx]))   = domList[domIndex]->global_zoom_ibegin + domList[domIndex]->global_zoom_ni-1;
+      nZoomBegin_.at((indexMap_[idx])) = 0; // domList[domIndex]->global_zoom_ibegin;
+      nZoomEnd_.at((indexMap_[idx]))   = domList[domIndex]->ni_glo.getValue() -1; //domList[domIndex]->global_zoom_ibegin + domList[domIndex]->global_zoom_ni-1;
 
       dataBegin_.at(indexMap_[idx]) = domList[domIndex]->data_ibegin.getValue();
@@ -325,6 +325,6 @@
       nBeginLocal_.at(indexMap_[idx]) = 0;
       nBeginGlobal_.at(indexMap_[idx]) = axisList[axisIndex]->begin.getValue();
-      nZoomBegin_.at((indexMap_[idx])) = axisList[axisIndex]->global_zoom_begin;
-      nZoomEnd_.at((indexMap_[idx])) = axisList[axisIndex]->global_zoom_begin + axisList[axisIndex]->global_zoom_n-1;
+      nZoomBegin_.at((indexMap_[idx])) = 0; //axisList[axisIndex]->global_zoom_begin;
+      nZoomEnd_.at((indexMap_[idx])) = axisList[axisIndex]->n_glo.getValue() - 1; //axisList[axisIndex]->global_zoom_begin + axisList[axisIndex]->global_zoom_n-1;
 
       dataBegin_.at(indexMap_[idx]) = axisList[axisIndex]->data_begin.getValue();
@@ -587,4 +587,5 @@
   localDataIndex_.resize(indexLocalDataOnClientCount);
   localMaskIndex_.resize(indexSend2ServerCount);
+  globalDataIndex_.rehash(std::ceil(indexLocalDataOnClientCount/globalDataIndex_.max_load_factor())); //globalLocalDataSendToServerMap_.reserve(indexSend2ServerCount);
   globalLocalDataSendToServerMap_.rehash(std::ceil(indexSend2ServerCount/globalLocalDataSendToServerMap_.max_load_factor())); //globalLocalDataSendToServerMap_.reserve(indexSend2ServerCount);
 
@@ -652,4 +653,10 @@
           if (gridMask_(gridMaskIndex))
           {
+            size_t globalIndex = 0;
+            for (int k = 0; k < numElement_; ++k)
+            {
+              globalIndex += (currentGlobalIndex[k])*elementNGlobal_[k];
+            }
+            globalDataIndex_[globalIndex] = indexLocalDataOnClientCount;
             localDataIndex_[indexLocalDataOnClientCount] = countLocalData;
             bool isIndexOnServer = true;
@@ -661,9 +668,4 @@
             if (isIndexOnServer)
             {
-              size_t globalIndex = 0;
-              for (int k = 0; k < numElement_; ++k)
-              {
-                globalIndex += (currentGlobalIndex[k])*elementNGlobal_[k];
-              }
               globalLocalDataSendToServerMap_[globalIndex] = indexLocalDataOnClientCount;
               localMaskIndex_[indexSend2ServerCount] = gridMaskIndex;
@@ -736,4 +738,10 @@
 }
 
+CDistributionClient::GlobalLocalDataMap& CDistributionClient::getGlobalDataIndexOnClient()
+{
+  if (!isComputed_) createGlobalIndexSendToServer();
+  return globalDataIndex_;
+}
+
 /*!
   Return local data index of client
Index: /XIOS/dev/dev_olga/src/distribution_client.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution_client.hpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/distribution_client.hpp	(revision 1129)
@@ -45,4 +45,5 @@
     virtual const std::vector<int>& getLocalDataIndexOnClient();
     GlobalLocalDataMap& getGlobalLocalDataSendToServer();
+    GlobalLocalDataMap& getGlobalDataIndexOnClient();
     const std::vector<int>& getLocalMaskIndexOnClient();
 
@@ -80,4 +81,5 @@
     //!< LocalData index on client
     GlobalLocalDataMap globalLocalDataSendToServerMap_;
+    GlobalLocalDataMap globalDataIndex_;
     std::vector<int> localDataIndex_;
     std::vector<int> localMaskIndex_;
Index: /XIOS/dev/dev_olga/src/distribution_server.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution_server.cpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/distribution_server.cpp	(revision 1129)
@@ -37,13 +37,13 @@
 }
 
-CDistributionServer::CDistributionServer(int rank, 
-                                         const std::vector<CArray<int,1> >& globalIndexEachDimension,
-                                         const std::vector<int>& nGlobal)
-  : CDistribution(rank, nGlobal.size()), nGlobal_(nGlobal), nZoomBeginGlobal_(),
-    nZoomSize_(), nZoomBegin_(), globalLocalIndexMap_(), 
-    globalIndexEachDimension_(globalIndexEachDimension)
-{
-  createGlobalIndexFromIndex(globalIndexEachDimension, nGlobal);
-}
+// CDistributionServer::CDistributionServer(int rank, 
+//                                          const std::vector<CArray<int,1> >& globalIndexEachDimension,
+//                                          const std::vector<int>& nGlobal)
+//   : CDistribution(rank, nGlobal.size()), nGlobal_(nGlobal), nZoomBeginGlobal_(),
+//     nZoomSize_(), nZoomBegin_(), globalLocalIndexMap_(), 
+//     globalIndexEachDimension_(globalIndexEachDimension)
+// {
+//   createGlobalIndexFromIndex(globalIndexEachDimension, nGlobal);
+// }
 
 CDistributionServer::~CDistributionServer()
@@ -101,51 +101,51 @@
 }
 
-void CDistributionServer::createGlobalIndexFromIndex(const std::vector<CArray<int,1> >& globalIndexOnEachDimension,
-                                                     const std::vector<int>& nbGlobal)
-{
-  size_t idx = 0, ssize = 1;
-  for (int i = 0; i < globalIndexOnEachDimension.size(); ++i) ssize *= globalIndexOnEachDimension[i].numElements();
-
-  this->globalIndex_.resize(ssize);
-  size_t nbDim = nbGlobal.size();
-  std::vector<int> idxLoop(nbDim,0);
-  std::vector<int> currentIndex(nbDim);
-  int innerLoopSize = globalIndexOnEachDimension[0].numElements();
-
-  globalLocalIndexMap_.rehash(std::ceil(ssize/globalLocalIndexMap_.max_load_factor()));
-  while (idx<ssize)
-  {
-    for (int i = 0; i < nbDim-1; ++i)
-    {
-      if (idxLoop[i] == globalIndexOnEachDimension[i].numElements())
-      {
-        idxLoop[i] = 0;
-        ++idxLoop[i+1];
-      }
-    }
-
-    for (int i = 1; i < nbDim; ++i)
-      currentIndex[i] = globalIndexOnEachDimension[i](idxLoop[i]);
-
-    size_t mulDim, globalIndex;
-    for (int i = 0; i < innerLoopSize; ++i)
-    {
-      mulDim = 1;
-      globalIndex = globalIndexOnEachDimension[0](i);
-
-      for (int k = 0; k < nbDim; ++k)
-      {
-        mulDim *= nbGlobal[k];
-        globalIndex += (currentIndex[k])*mulDim;
-      }
-      globalLocalIndexMap_[globalIndex] = idx;
-      this->globalIndex_(idx) = globalIndex;
-
-      ++idx;
-    }
-    idxLoop[0] += innerLoopSize;
-  }
-
-}
+// void CDistributionServer::createGlobalIndexFromIndex(const std::vector<CArray<int,1> >& globalIndexOnEachDimension,
+//                                                      const std::vector<int>& nbGlobal)
+// {
+//   size_t idx = 0, ssize = 1;
+//   for (int i = 0; i < globalIndexOnEachDimension.size(); ++i) ssize *= globalIndexOnEachDimension[i].numElements();
+
+//   this->globalIndex_.resize(ssize);
+//   size_t nbDim = nbGlobal.size();
+//   std::vector<int> idxLoop(nbDim,0);
+//   std::vector<int> currentIndex(nbDim);
+//   int innerLoopSize = globalIndexOnEachDimension[0].numElements();
+
+//   globalLocalIndexMap_.rehash(std::ceil(ssize/globalLocalIndexMap_.max_load_factor()));
+//   while (idx<ssize)
+//   {
+//     for (int i = 0; i < nbDim-1; ++i)
+//     {
+//       if (idxLoop[i] == globalIndexOnEachDimension[i].numElements())
+//       {
+//         idxLoop[i] = 0;
+//         ++idxLoop[i+1];
+//       }
+//     }
+
+//     for (int i = 1; i < nbDim; ++i)
+//       currentIndex[i] = globalIndexOnEachDimension[i](idxLoop[i]);
+
+//     size_t mulDim, globalIndex;
+//     for (int i = 0; i < innerLoopSize; ++i)
+//     {
+//       mulDim = 1;
+//       globalIndex = globalIndexOnEachDimension[0](i);
+
+//       for (int k = 0; k < nbDim; ++k)
+//       {
+//         mulDim *= nbGlobal[k];
+//         globalIndex += (currentIndex[k])*mulDim;
+//       }
+//       globalLocalIndexMap_[globalIndex] = idx;
+//       this->globalIndex_(idx) = globalIndex;
+
+//       ++idx;
+//     }
+//     idxLoop[0] += innerLoopSize;
+//   }
+
+// }
 
 /*!
@@ -156,12 +156,16 @@
 CArray<size_t,1> CDistributionServer::computeLocalIndex(const CArray<size_t,1>& globalIndex)
 {
-  int ssize = globalIndex.numElements();
-  CArray<size_t,1> localIndex(ssize);
+  size_t ssize = globalIndex.numElements();
+  size_t localIndexSize = std::min(globalIndex_.numElements(), ssize);
+  CArray<size_t,1> localIndex(localIndexSize);
   GlobalLocalMap::const_iterator ite = globalLocalIndexMap_.end(), it;
-  for (int idx = 0; idx < ssize; ++idx)
+  for (int idx = 0, i = 0; idx < ssize; ++idx)
   {
     it = globalLocalIndexMap_.find(globalIndex(idx));
     if (ite != it)
+    {
       localIndex(idx) = it->second;
+      ++i;
+    }
   }
 
Index: /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/io/nc4_data_output.cpp	(revision 1129)
@@ -50,4 +50,5 @@
       void CNc4DataOutput::writeDomain_(CDomain* domain)
       {
+        domain->computeWrittenIndex();
         if (domain->type == CDomain::type_attr::unstructured)
         {
@@ -59,4 +60,5 @@
         }
 
+        
          CContext* context = CContext::getCurrent() ;
          CContextServer* server=context->server ;
@@ -107,4 +109,46 @@
                              : latid;
 */
+
+         CArray<size_t, 1>& indexToWrite = domain->localIndexToWriteOnServer;
+         int nbWritten = indexToWrite.numElements();
+         CArray<double,1> writtenLat, writtenLon;
+         CArray<double,2> writtenBndsLat, writtenBndsLon;
+         CArray<double,1> writtenArea;
+
+         if (domain->hasLonLat)
+         {
+           writtenLat.resize(nbWritten);
+           writtenLon.resize(nbWritten);
+           for (int idx = 0; idx < nbWritten; ++idx)
+           {
+              writtenLat(idx) = domain->latvalue(indexToWrite(idx));
+              writtenLon(idx) = domain->lonvalue(indexToWrite(idx));
+           }
+         
+
+           if (domain->hasBounds)
+           {         
+             int nvertex = domain->nvertex, idx;
+             writtenBndsLat.resize(nvertex, nbWritten);
+             writtenBndsLon.resize(nvertex, nbWritten);
+             CArray<double,2>& boundslat = domain->bounds_latvalue;
+             CArray<double,2>& boundslon = domain->bounds_lonvalue;   
+             for (idx = 0; idx < nbWritten; ++idx)
+               for (int nv = 0; nv < nvertex; ++nv)
+               {
+                 writtenBndsLat(nv, idx) = boundslat(nv, int(indexToWrite(idx)));
+                 writtenBndsLon(nv, idx) = boundslon(nv, int(indexToWrite(idx)));
+               }
+           }
+         }
+
+         if (domain->hasArea)
+         {
+           writtenArea.resize(nbWritten);           
+           for (int idx = 0; idx < nbWritten; ++idx)
+           {
+              writtenArea(idx) = domain->areavalue(indexToWrite(idx));                      
+           }
+         }
 
          try
@@ -225,14 +269,31 @@
                  if (domain->hasLonLat)
                  {
+                   // CArray<size_t, 1>& indexToWrite = domain->localIndexToWriteOnServer;
+                   // int nbWritten = indexToWrite.numElements();
+                   // CArray<double,1> writtenLat(nbWritten), writtenLon(nbWritten);
+                   // for (int idx = 0; idx < nbWritten; ++idx)
+                   // {
+                   //    writtenLat(idx) = domain->latvalue(indexToWrite(idx));
+                   //    writtenLon(idx) = domain->lonvalue(indexToWrite(idx));
+                   // }
                    switch (domain->type)
                    {
-                     case CDomain::type_attr::curvilinear :
-                       SuperClassWriter::writeData(domain->latvalue, latid, isCollective, 0);
-                       SuperClassWriter::writeData(domain->lonvalue, lonid, isCollective, 0);
+                     case CDomain::type_attr::curvilinear :                       
+                        
+                       // SuperClassWriter::writeData(domain->latvalue, latid, isCollective, 0);
+                       // SuperClassWriter::writeData(domain->lonvalue, lonid, isCollective, 0);
+                       SuperClassWriter::writeData(writtenLat, latid, isCollective, 0);
+                       SuperClassWriter::writeData(writtenLon, lonid, isCollective, 0);
                        break;
                      case CDomain::type_attr::rectilinear :
-                       CArray<double,1> lat = domain->latvalue(Range(fromStart,toEnd,domain->zoom_ni)) ;
+//                        CArray<double,1> lat = domain->latvalue(Range(fromStart,toEnd,domain->zoom_ni)) ;
+//                        SuperClassWriter::writeData(CArray<double,1>(lat.copy()), latid, isCollective, 0);
+//                        CArray<double,1> lon = domain->lonvalue(Range(0,domain->zoom_ni-1)) ;
+// //                       CArray<double,1> lon = domain->lonvalue(Range(0,local_size_write[1]-1)) ;
+//                        SuperClassWriter::writeData(CArray<double,1>(lon.copy()), lonid, isCollective, 0);
+
+                       CArray<double,1> lat = writtenLat(Range(fromStart,toEnd,domain->zoom_ni)) ;
                        SuperClassWriter::writeData(CArray<double,1>(lat.copy()), latid, isCollective, 0);
-                       CArray<double,1> lon = domain->lonvalue(Range(0,domain->zoom_ni-1)) ;
+                       CArray<double,1> lon = writtenLon(Range(0,domain->zoom_ni-1)) ;
 //                       CArray<double,1> lon = domain->lonvalue(Range(0,local_size_write[1]-1)) ;
                        SuperClassWriter::writeData(CArray<double,1>(lon.copy()), lonid, isCollective, 0);
@@ -242,11 +303,32 @@
                    if (domain->hasBounds)
                    {
-                     SuperClassWriter::writeData(domain->bounds_lonvalue, bounds_lonid, isCollective, 0);
-                     SuperClassWriter::writeData(domain->bounds_latvalue, bounds_latid, isCollective, 0);
+                     // CArray<double,2> writtenBndsLat(nbWritten,2), writtenBndsLon(nbWritten,2);
+                     // for (int idx = 0; idx < nbWritten; ++idx)
+                     //   for (int nv = 0; nv < domain->nvertex; ++nv)
+                     //   {
+                     //     writtenBndsLat(idx) = domain->bounds_latvalue(nv, indexToWrite(idx));
+                     //     writtenBndsLon(idx) = domain->bounds_lonvalue(nv, indexToWrite(idx));
+                     //   }
+
+                     // SuperClassWriter::writeData(domain->bounds_lonvalue, bounds_lonid, isCollective, 0);
+                     // SuperClassWriter::writeData(domain->bounds_latvalue, bounds_latid, isCollective, 0);
+                     SuperClassWriter::writeData(writtenBndsLon, bounds_lonid, isCollective, 0);
+                     SuperClassWriter::writeData(writtenBndsLat, bounds_latid, isCollective, 0);
                    }
                  }
 
                  if (domain->hasArea)
-                   SuperClassWriter::writeData(domain->areavalue, areaId, isCollective, 0);
+                 {
+                   // CArray<size_t, 1>& indexToWrite = domain->localIndexToWriteOnServer;
+                   // int nbWritten = indexToWrite.numElements();
+                   // CArray<double,1> writtenArea(nbWritten);
+                   // for (int idx = 0; idx < nbWritten; ++idx)
+                   // {
+                   //    writtenArea(idx) = domain->areavalue(indexToWrite(idx));                      
+                   // }
+
+                   SuperClassWriter::writeData(writtenArea, areaId, isCollective, 0);
+                   // SuperClassWriter::writeData(domain->areavalue, areaId, isCollective, 0);
+                 }
 
                  SuperClassWriter::definition_start();
@@ -334,14 +416,12 @@
                        start[0]=domain->zoom_jbegin-domain->global_zoom_jbegin;
                        count[1]=domain->zoom_ni ; count[0]=domain->zoom_nj ;
-                       // start[1]= start_write[0];
-                       // start[0]= start_write[1];
-                       // count[1]= count_write[0];
-                       // count[0]= count_write[1];
                      }
 
                      if (domain->hasLonLat)
                      {
-                       SuperClassWriter::writeData(domain->latvalue, latid, isCollective, 0,&start,&count);
-                       SuperClassWriter::writeData(domain->lonvalue, lonid, isCollective, 0,&start,&count);
+                       // SuperClassWriter::writeData(domain->latvalue, latid, isCollective, 0,&start,&count);
+                       // SuperClassWriter::writeData(domain->lonvalue, lonid, isCollective, 0,&start,&count);
+                       SuperClassWriter::writeData(writtenLat, latid, isCollective, 0,&start,&count);
+                       SuperClassWriter::writeData(writtenLon, lonid, isCollective, 0,&start,&count);
                      }
                      break;
@@ -357,22 +437,22 @@
                          start[0]=0 ;
                          count[0]=0 ;
-                         SuperClassWriter::writeData(domain->latvalue, latid, isCollective, 0,&start,&count);
-                         SuperClassWriter::writeData(domain->lonvalue, lonid, isCollective, 0,&start,&count);
-
+                         // SuperClassWriter::writeData(domain->latvalue, latid, isCollective, 0,&start,&count);
+                         // SuperClassWriter::writeData(domain->lonvalue, lonid, isCollective, 0,&start,&count);
+
+                         SuperClassWriter::writeData(writtenLat, latid, isCollective, 0,&start,&count);
+                         SuperClassWriter::writeData(writtenLon, lonid, isCollective, 0,&start,&count);
                        }
                        else
-                       {
-                         // start[0]= start_write[1];
-                         // count[0]= count_write[1];
+                       { 
                          start[0]=domain->zoom_jbegin-domain->global_zoom_jbegin;
                          count[0]=domain->zoom_nj;
-                         CArray<double,1> lat = domain->latvalue(Range(fromStart,toEnd,domain->zoom_ni)) ;
+                         // CArray<double,1> lat = domain->latvalue(Range(fromStart,toEnd,domain->zoom_ni));
+                         CArray<double,1> lat = writtenLat(Range(fromStart,toEnd,domain->zoom_ni));
                          SuperClassWriter::writeData(CArray<double,1>(lat.copy()), latid, isCollective, 0,&start,&count);
 
-                         // start[0]= start_write[0];
-                         // count[0]= count_write[0];
                          start[0]=domain->zoom_ibegin-domain->global_zoom_ibegin;
                          count[0]=domain->zoom_ni;
-                         CArray<double,1> lon=domain->lonvalue(Range(0,domain->zoom_ni-1)) ;
+                         // CArray<double,1> lon=domain->lonvalue(Range(0,domain->zoom_ni-1));
+                         CArray<double,1> lon = writtenLon(Range(0,domain->zoom_ni-1));
                          SuperClassWriter::writeData(CArray<double,1>(lon.copy()), lonid, isCollective, 0,&start,&count);
                        }
@@ -401,6 +481,8 @@
                    }
 
-                 SuperClassWriter::writeData(domain->bounds_lonvalue, bounds_lonid, isCollective, 0, &start, &count);
-                 SuperClassWriter::writeData(domain->bounds_latvalue, bounds_latid, isCollective, 0, &start, &count);
+                 // SuperClassWriter::writeData(domain->bounds_lonvalue, bounds_lonid, isCollective, 0, &start, &count);
+                 // SuperClassWriter::writeData(domain->bounds_latvalue, bounds_latid, isCollective, 0, &start, &count);
+                   SuperClassWriter::writeData(writtenBndsLon, bounds_lonid, isCollective, 0, &start, &count);
+                   SuperClassWriter::writeData(writtenBndsLat, bounds_latid, isCollective, 0, &start, &count);
                  }
 
@@ -421,12 +503,8 @@
                      count[1] = domain->zoom_ni;
                      count[0] = domain->zoom_nj;
-
-                     // start[1]= start_write[0];
-                     // start[0]= start_write[1];
-                     // count[1]= count_write[0];
-                     // count[0]= count_write[1];
                    }
 
-                   SuperClassWriter::writeData(domain->areavalue, areaId, isCollective, 0, &start, &count);
+                   // SuperClassWriter::writeData(domain->areavalue, areaId, isCollective, 0, &start, &count);
+                   SuperClassWriter::writeData(writtenArea, areaId, isCollective, 0, &start, &count);
                  }
 
@@ -1056,12 +1134,6 @@
         axis->checkAttributes();
 
-        // int local_size_write  = axis->getLocalWriteSize();
-        // int global_size_write = axis->getGlobalWriteSize();
-        // int start_write = axis->getStartWriteIndex();
-        // int count_write = axis->getCountWriteIndex();
-
-
-        // if ((0 == local_size_write) && (MULTI_FILE == SuperClass::type)) return;
-
+        axis->computeWrittenIndex();
+       
         int zoom_size  = (MULTI_FILE == SuperClass::type) ? axis->zoom_n
                                                           : axis->global_zoom_n;
@@ -1114,10 +1186,16 @@
             SuperClassWriter::definition_end();
 
+            CArray<size_t, 1>& indexToWrite = axis->localIndexToWriteOnServer;
+            int nbWritten = indexToWrite.numElements();
+            CArray<double,1> axis_value(indexToWrite.numElements());
+            for (int i = 0; i < nbWritten; i++) axis_value(i) = axis->value(indexToWrite(i));
+            CArray<double,2> axis_bounds;
+
             switch (SuperClass::type)
             {
               case MULTI_FILE:
               {
-                CArray<double,1> axis_value(axis->zoom_n);
-                for (int i = 0; i < axis->zoom_n; i++) axis_value(i) = axis->value(i);
+                // CArray<double,1> axis_value(axis->zoom_n);
+                // for (int i = 0; i < axis->zoom_n; i++) axis_value(i) = axis->value(i);
                 SuperClassWriter::writeData(axis_value, axisid, isCollective, 0);
 
@@ -1131,6 +1209,6 @@
               case ONE_FILE:
               {
-                CArray<double,1> axis_value(axis->zoom_n);
-                axis_value = axis->value;
+                // CArray<double,1> axis_value(axis->zoom_n);
+                // axis_value = axis->value;
                 std::vector<StdSize> start(1), startBounds(2) ;
                 std::vector<StdSize> count(1), countBounds(2) ;
@@ -1142,5 +1220,13 @@
 
                 if (!axis->bounds.isEmpty())
+                {
+                  axis_bounds.resize(2, indexToWrite.numElements());
+                  for (int i = 0; i < nbWritten; ++i)
+                  {
+                    axis_bounds(0, i) = axis->bounds(0, int(indexToWrite(i)));
+                    axis_bounds(1, i) = axis->bounds(1, int(indexToWrite(i)));
+                  }
                   SuperClassWriter::writeData(axis->bounds, axisBoundsId, isCollective, 0, &startBounds, &countBounds);
+                }
 
                 SuperClassWriter::definition_start();
@@ -2371,5 +2457,5 @@
            msg.append(context->getId()); msg.append("\n");
            msg.append(e.what());
-           ERROR("CNc4DataOutput::writeFieldData_ (CField*  field)", << msg);
+               ERROR("CNc4DataOutput::writeFieldData_ (CField*  field)", << msg);
          }
       }
Index: /XIOS/dev/dev_olga/src/node/axis.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/axis.cpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/axis.cpp	(revision 1129)
@@ -28,4 +28,5 @@
       , numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
       , transformationMap_(), hasValue(false), doZoomByIndex_(false)
+      , computedWrittenIndex_(false)
    {
    }
@@ -38,4 +39,5 @@
       , numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
       , transformationMap_(), hasValue(false), doZoomByIndex_(false)
+      , computedWrittenIndex_(false)
    {
    }
@@ -129,38 +131,4 @@
    {
      return offsetWrittenIndexes_;
-   }
-
-   /*!
-     Returns the start of indexes written by each server.
-     \return the start of indexes written by each server
-   */
-   int CAxis::getStartWriteIndex() const
-   {
-     return start_write_index_;
-   }
-
-   /*!
-     Returns the count of indexes written by each server.
-     \return the count of indexes written by each server
-   */
-   int CAxis::getCountWriteIndex() const
-   {
-     return count_write_index_;
-   }
-
-   /*!
-     Returns the local data written by each server.     
-   */
-   int CAxis::getLocalWriteSize() const
-   {
-     return local_write_size_;
-   }
-
-   /*!
-     Returns the global data written by all server.     
-   */
-   int CAxis::getGlobalWriteSize() const
-   {
-     return global_write_size_;
    }
 
@@ -454,7 +422,7 @@
      else
      {
-       sendDistributedAttributes();
-       sendDistributionAttribute(globalDim, orderPositionInGrid, distType);
+       sendDistributedAttributes();       
      }
+     sendDistributionAttribute(globalDim, orderPositionInGrid, distType);
   }
 
@@ -639,4 +607,39 @@
     }
   }
+
+   void CAxis::computeWrittenIndex()
+   {  
+      if (computedWrittenIndex_) return;
+      computedWrittenIndex_ = true;
+
+      CContext* context=CContext::getCurrent() ;
+      CContextClient* client = context->client; 
+
+      std::vector<int> nBegin(1), nSize(1), nBeginGlobal(1), nGlob(1);
+      nBegin[0]       = zoom_begin;
+      nSize[0]        = zoom_n;   
+      nBeginGlobal[0] = 0; 
+      nGlob[0]        = n_glo;
+      CDistributionServer srvDist(client->clientSize, nBegin, nSize, nBeginGlobal, nGlob); 
+      const CArray<size_t,1>& writtenGlobalIndex  = srvDist.getGlobalIndex();
+
+      size_t nbWritten = 0, indGlo;      
+      boost::unordered_map<size_t,size_t>::const_iterator itb = globalLocalIndexMap_.begin(),
+                                                          ite = globalLocalIndexMap_.end(), it;          
+      CArray<size_t,1>::const_iterator itSrvb = writtenGlobalIndex.begin(),
+                                       itSrve = writtenGlobalIndex.end(), itSrv;
+      localIndexToWriteOnServer.resize(writtenGlobalIndex.numElements());
+      for (itSrv = itSrvb; itSrv != itSrve; ++itSrv)
+      {
+        indGlo = *itSrv;
+        if (ite != globalLocalIndexMap_.find(indGlo))
+        {
+          localIndexToWriteOnServer(nbWritten) = globalLocalIndexMap_[indGlo];
+          ++nbWritten;
+        }                 
+      }
+
+   }
+
 
 
@@ -875,8 +878,10 @@
           CMessage& msg = msgs.back();
           msg << this->getId();
-          msg << index.getValue() << dataIndex << zoom_index.getValue() << mask.getValue();
+          msg << index.getValue() << dataIndex << mask.getValue();
+
+          msg << doZoomByIndex_;
+          if (doZoomByIndex_) msg << zoom_index.getValue();
           msg << hasValue;
           if (hasValue) msg << value.getValue();
-
           msg << hasBounds_;
           if (hasBounds_) msg << bounds.getValue();
@@ -913,8 +918,14 @@
     buffer >> tmp_data_index;
     data_index.reference(tmp_data_index);
-    buffer >> tmp_zoom_index;
-    zoom_index.reference(tmp_zoom_index);
     buffer >> tmp_mask;
     mask.reference(tmp_mask);
+
+    buffer >> doZoomByIndex_;
+    if (doZoomByIndex_)
+    {
+      buffer >> tmp_zoom_index;
+      zoom_index.reference(tmp_zoom_index);
+    }
+
     buffer >> hasValue;
     if (hasValue)
@@ -931,10 +942,7 @@
     }
 
-    {      
-      count_write_index_ = zoom_index.numElements();            
-      start_write_index_ = 0;
-      local_write_size_ = count_write_index_;
-      global_write_size_ = count_write_index_;
-    }
+    data_begin.setValue(0);
+    globalLocalIndexMap_.rehash(std::ceil(index.numElements()/globalLocalIndexMap_.max_load_factor()));
+    for (int idx = 0; idx < index.numElements(); ++idx) globalLocalIndexMap_[idx] = index(idx);
   }
 
@@ -1065,4 +1073,5 @@
     get(axisId)->recvDistributedAttributes(ranks, buffers);
   }
+
 
   void CAxis::recvDistributedAttributes(vector<int>& ranks, vector<CBufferIn*> buffers)
@@ -1099,6 +1108,7 @@
       nbData += vec_indi[idx].numElements();
     }
-    
+
     index.resize(nbData);
+    globalLocalIndexMap_.rehash(std::ceil(index.numElements()/globalLocalIndexMap_.max_load_factor()));
     CArray<int,1> nonCompressedData(nbData);    
     mask.resize(nbData);
@@ -1118,4 +1128,5 @@
       {
         index(nbData) = indi(n);
+        globalLocalIndexMap_[indi(n)] = nbData;
         nonCompressedData(nbData) = (0 <= dataIndi(n)) ? nbData : -1;
         mask(nbData) = maskIndi(n);
@@ -1149,4 +1160,5 @@
       }
     }
+    data_begin.setValue(0);
 
     if (doZoomByIndex_)
@@ -1170,14 +1182,4 @@
       }
     }
-
-
-    // {
-    //   CContextServer* server = CContext::getCurrent()->server;
-    //   count_write_index_ = zoom_index.numElements();      
-    //   MPI_Scan(&count_write_index_, &start_write_index_, 1, MPI_INT, MPI_SUM, server->intraComm);
-    //   global_write_size_ = start_write_index_;
-    //   start_write_index_ -= count_write_index_;
-    //   local_write_size_ = count_write_index_;      
-    // }
   }
 
